Index: /branches/multichoice/gui/scripts/vtkstreamlinesviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/vtkstreamlinesviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/vtkstreamlinesviewer.tcl	(revision 6371)
@@ -72,5 +72,4 @@
     private method BuildSurfaceTab {}
     private method DrawLegend {}
-    private method Combo { option }
     private method Connect {}
     private method CurrentDatasets {args}
@@ -91,4 +90,5 @@
     private method IsValidObject { dataobj }
     private method LeaveLegend {}
+    private method LegendTitleAction { option }
     private method MotionLegend { x y }
     private method Pan {option x y}
@@ -101,8 +101,9 @@
     private method ReceiveDataset { args }
     private method ReceiveImage { args }
-    private method ReceiveLegend { colormap title vmin vmax size }
+    private method ReceiveLegend { colormap title min max size }
     private method RequestLegend {}
     private method Rotate {option x y}
     private method SetCurrentColormap { color }
+    private method SetCurrentFieldName { dataobj }
     private method SetLegendTip { x y }
     private method SetObjectStyle { dataobj comp }
@@ -145,8 +146,7 @@
     private variable _curFldName ""
     private variable _curFldLabel ""
-    private variable _field ""
+    private variable _colorMode "vmag"; # Mode of colormap (vmag or scalar)
     private variable _streamlinesLength 0
     private variable _numSeeds 200
-    private variable _colorMode "vmag"; # Mode of colormap (vmag or scalar)
 
     private common _downloadPopup;      # download options from popup
@@ -301,5 +301,6 @@
     }
     pack $itk_component(reset) -side top -padx 2 -pady 2
-    Rappture::Tooltip::for $itk_component(reset) "Reset the view to the default zoom level"
+    Rappture::Tooltip::for $itk_component(reset) \
+        "Reset the view to the default zoom level"
 
     itk_component add zoomin {
@@ -552,7 +553,4 @@
     }
     array set params $settings
-    set params(-description) ""
-    set params(-param) ""
-    array set params $settings
 
     if {$params(-color) == "auto" || $params(-color) == "autoreset"} {
@@ -592,5 +590,4 @@
         set _dlist [lreplace $_dlist $pos $pos]
         array unset _obj2ovride $dataobj-*
-        array unset _settings $dataobj-*
         set changed 1
     }
@@ -653,5 +650,5 @@
             return $dlist
         }
-        -image {
+        "-image" {
             if {[llength $args] != 2} {
                 error "wrong # args: should be \"get -image view\""
@@ -667,5 +664,5 @@
         }
         default {
-            error "bad option \"$op\": should be -objects or -image"
+            error "bad option \"$op\": should be -objects, -visible or -image"
         }
     }
@@ -982,4 +979,5 @@
         if { [info exists _obj2ovride($dataobj-raise)] &&  $_first == "" } {
             set _first $dataobj
+            SetCurrentFieldName $dataobj
         }
         foreach comp [$dataobj components] {
@@ -1027,32 +1025,4 @@
             }
         }
-        $itk_component(field) choices delete 0 end
-        $itk_component(fieldmenu) delete 0 end
-        array unset _fields
-        set _curFldName ""
-        set _curFldLabel ""
-        foreach cname [$_first components] {
-            foreach fname [$_first fieldnames $cname] {
-                if { [info exists _fields($fname)] } {
-                    continue
-                }
-                foreach { label units components } \
-                    [$_first fieldinfo $fname] break
-                $itk_component(field) choices insert end "$fname" "$label"
-                $itk_component(fieldmenu) add radiobutton -label "$label" \
-                    -value $label -variable [itcl::scope _curFldLabel] \
-                    -selectcolor red \
-                    -activebackground $itk_option(-plotbackground) \
-                    -activeforeground $itk_option(-plotforeground) \
-                    -font "Arial 8" \
-                    -command [itcl::code $this Combo invoke]
-                set _fields($fname) [list $label $units $components]
-                if { $_curFldName == "" && $components == 3 } {
-                    set _curFldName $fname
-                    set _curFldLabel $label
-                }
-            }
-        }
-        $itk_component(field) value $_curFldLabel
     }
 
@@ -1299,8 +1269,4 @@
 itcl::body Rappture::VtkStreamlinesViewer::InitSettings { args } {
     foreach spec $args {
-        if { [info exists _settings($_first${spec})] } {
-            # Reset global setting with dataobj specific setting
-            set _settings($spec) $_settings($_first${spec})
-        }
         AdjustSetting $spec
     }
@@ -2068,5 +2034,5 @@
     radiobutton $inner.vtk_button -text "VTK data file" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Helvetica 9 " \
+        -font "Arial 9" \
         -value vtk
     Rappture::Tooltip::for $inner.vtk_button "Save as VTK data file."
@@ -2185,5 +2151,5 @@
 
 # ----------------------------------------------------------------------
-# USAGE: ReceiveLegend <colormap> <title> <vmin> <vmax> <size>
+# USAGE: ReceiveLegend <colormap> <title> <min> <max> <size>
 #
 # Invoked automatically whenever the "legend" command comes in from
@@ -2191,5 +2157,5 @@
 # specified <size> will follow.
 # ----------------------------------------------------------------------
-itcl::body Rappture::VtkStreamlinesViewer::ReceiveLegend { colormap title vmin vmax size } {
+itcl::body Rappture::VtkStreamlinesViewer::ReceiveLegend { colormap title min max size } {
     set _legendPending 0
     set _title $title
@@ -2255,7 +2221,7 @@
             $c bind colormap <Motion> [itcl::code $this MotionLegend %x %y]
         }
-        $c bind title <ButtonPress> [itcl::code $this Combo post]
-        $c bind title <Enter> [itcl::code $this Combo activate]
-        $c bind title <Leave> [itcl::code $this Combo deactivate]
+        $c bind title <ButtonPress> [itcl::code $this LegendTitleAction post]
+        $c bind title <Enter> [itcl::code $this LegendTitleAction enter]
+        $c bind title <Leave> [itcl::code $this LegendTitleAction leave]
         # Reset the item coordinates according the current size of the plot.
         $c itemconfigure title -text $title
@@ -2380,15 +2346,17 @@
 
 # ----------------------------------------------------------------------
-# USAGE: _dropdown post
-# USAGE: _dropdown unpost
-# USAGE: _dropdown select
-#
-# Used internally to handle the dropdown list for this combobox.  The
-# post/unpost options are invoked when the list is posted or unposted
-# to manage the relief of the controlling button.  The select option
-# is invoked whenever there is a selection from the list, to assign
-# the value back to the gauge.
-# ----------------------------------------------------------------------
-itcl::body Rappture::VtkStreamlinesViewer::Combo {option} {
+# USAGE: LegendTitleAction post
+# USAGE: LegendTitleAction enter
+# USAGE: LegendTitleAction leave
+# USAGE: LegendTitleAction save
+#
+# Used internally to handle the dropdown list for the fields menu combobox.
+# The post option is invoked when the field title is pressed to launch the
+# dropdown.  The enter option is invoked when the user mouses over the field
+# title. The leave option is invoked when the user moves the mouse away
+# from the field title.  The save option is invoked whenever there is a
+# selection from the list, to alert the visualization server.
+# ----------------------------------------------------------------------
+itcl::body Rappture::VtkStreamlinesViewer::LegendTitleAction {option} {
     set c $itk_component(view)
     switch -- $option {
@@ -2400,16 +2368,16 @@
             tk_popup $itk_component(fieldmenu) $x $y
         }
-        activate {
+        enter {
             $c itemconfigure title -fill red
         }
-        deactivate {
+        leave {
             $c itemconfigure title -fill white
         }
-        invoke {
+        save {
             $itk_component(field) value $_curFldLabel
             AdjustSetting -field
         }
         default {
-            error "bad option \"$option\": should be post, unpost, select"
+            error "bad option \"$option\": should be post, enter, leave or save"
         }
     }
@@ -2436,2 +2404,34 @@
     set _view(-zoom) 1.0
 }
+
+itcl::body Rappture::VtkStreamlinesViewer::SetCurrentFieldName { dataobj } {
+    set _first $dataobj
+    $itk_component(field) choices delete 0 end
+    $itk_component(fieldmenu) delete 0 end
+    array unset _fields
+    set _curFldName ""
+    set _curFldLabel ""
+    foreach cname [$_first components] {
+        foreach fname [$_first fieldnames $cname] {
+            if { [info exists _fields($fname)] } {
+                continue
+            }
+            foreach { label units components } \
+                [$_first fieldinfo $fname] break
+            $itk_component(field) choices insert end "$fname" "$label"
+            $itk_component(fieldmenu) add radiobutton -label "$label" \
+                -value $label -variable [itcl::scope _curFldLabel] \
+                -selectcolor red \
+                -activebackground $itk_option(-plotbackground) \
+                -activeforeground $itk_option(-plotforeground) \
+                -font "Arial 8" \
+                -command [itcl::code $this LegendTitleAction save]
+            set _fields($fname) [list $label $units $components]
+            if { $_curFldName == "" && $components == 3 } {
+                set _curFldName $fname
+                set _curFldLabel $label
+            }
+        }
+    }
+    $itk_component(field) value $_curFldLabel
+}
Index: /branches/multichoice/gui/scripts/vtksurfaceviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/vtksurfaceviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/vtksurfaceviewer.tcl	(revision 6371)
@@ -69,5 +69,4 @@
     private method BuildDownloadPopup { widget command }
     private method BuildSurfaceTab {}
-    private method Combo { option }
     private method Connect {}
     private method CurrentDatasets {args}
@@ -85,4 +84,5 @@
     private method IsValidObject { dataobj }
     private method LeaveLegend {}
+    private method LegendTitleAction { option }
     private method MotionLegend { x y }
     private method Pan {option x y}
@@ -95,5 +95,5 @@
     private method ReceiveDataset { args }
     private method ReceiveImage { args }
-    private method ReceiveLegend { colormap title vmin vmax size }
+    private method ReceiveLegend { colormap title min max size }
     private method RequestLegend {}
     private method Rotate {option x y}
@@ -139,9 +139,8 @@
     private variable _legendPending 0
     private variable _rotatePending 0
-    private variable _field ""
-    private variable _colorMode "scalar"; # Mode of colormap (vmag or scalar)
     private variable _fields
     private variable _curFldName ""
     private variable _curFldLabel ""
+    private variable _colorMode "scalar"; # Mode of colormap (vmag or scalar)
 
     private common _downloadPopup;      # download options from popup
@@ -474,7 +473,4 @@
     }
     array set params $settings
-    set params(-description) ""
-    set params(-param) ""
-    array set params $settings
 
     if {$params(-color) == "auto" || $params(-color) == "autoreset"} {
@@ -513,5 +509,4 @@
         set _dlist [lreplace $_dlist $pos $pos]
         array unset _obj2ovride $dataobj-*
-        array unset _settings $dataobj-*
         set changed 1
     }
@@ -574,5 +569,5 @@
             return $dlist
         }
-        -image {
+        "-image" {
             if {[llength $args] != 2} {
                 error "wrong # args: should be \"get -image view\""
@@ -588,5 +583,5 @@
         }
         default {
-            error "bad option \"$op\": should be -objects or -image"
+            error "bad option \"$op\": should be -objects, -visible or -image"
         }
     }
@@ -1194,8 +1189,4 @@
 itcl::body Rappture::VtkSurfaceViewer::InitSettings { args } {
     foreach spec $args {
-        if { [info exists _settings($_first${spec})] } {
-            # Reset global setting with dataobj specific setting
-            set _settings($spec) $_settings($_first${spec})
-        }
         AdjustSetting $spec
     }
@@ -1318,7 +1309,24 @@
         "-isolinecolor" {
             set _changed($what) 1
-            set color [$itk_component(isolineColor) value]
-            set _settings($what) $color
-            SendCmd "contour2d linecolor [Color2RGB $color]"
+            set color [$itk_component(isolinecolor) value]
+            if { $color == "none" } {
+                if { $_settings(-isolinesvisible) } {
+                    set _changed(-isolinesvisible) 1
+                    foreach tag [CurrentDatasets -visible] {
+                        SendCmd "contour2d visible 0 $tag"
+                    }
+                    set _settings(-isolinesvisible) 0
+                }
+            } else {
+                set _settings($what) $color
+                if { !$_settings(-isolinesvisible) } {
+                    set _changed(-isolinesvisible) 1
+                    foreach tag [CurrentDatasets -visible] {
+                        SendCmd "contour2d visible 1 $tag"
+                    }
+                    set _settings(-isolinesvisible) 1
+                }
+                SendCmd "contour2d linecolor [Color2RGB $color]"
+            }
             DrawLegend
         }
@@ -1328,4 +1336,7 @@
             SendCmd "contour2d visible 0"
             if { $bool } {
+                if { [$itk_component(isolinecolor) value] != $_settings(-isolinecolor)} {
+                    $itk_component(isolinecolor) value $_settings(-isolinecolor)
+                }
                 foreach tag [CurrentDatasets -visible] {
                     SendCmd "contour2d visible $bool $tag"
@@ -1546,5 +1557,5 @@
 
     label $inner.linecolor_l -text "Isolines" -font "Arial 9"
-    itk_component add isolineColor {
+    itk_component add isolinecolor {
         Rappture::Combobox $inner.linecolor -width 10 -editable 0
     }
@@ -1561,5 +1572,5 @@
         "none"               "none"
 
-    $itk_component(isolineColor) value "white"
+    $itk_component(isolinecolor) value $_settings(-isolinecolor)
     bind $inner.linecolor <<Value>> \
         [itcl::code $this AdjustSetting -isolinecolor]
@@ -1797,5 +1808,5 @@
                     SendCmd "camera zoom $_view($what)"
                 }
-             }
+            }
         }
     }
@@ -1831,10 +1842,10 @@
     radiobutton $inner.vtk_button -text "VTK data file" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Arial 9 " \
+        -font "Arial 9" \
         -value vtk
     Rappture::Tooltip::for $inner.vtk_button "Save as VTK data file."
     radiobutton $inner.image_button -text "Image File" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Arial 9 " \
+        -font "Arial 9" \
         -value image
     Rappture::Tooltip::for $inner.image_button \
@@ -2170,7 +2181,7 @@
     }
 
-    $c bind title <ButtonPress> [itcl::code $this Combo post]
-    $c bind title <Enter> [itcl::code $this Combo activate]
-    $c bind title <Leave> [itcl::code $this Combo deactivate]
+    $c bind title <ButtonPress> [itcl::code $this LegendTitleAction post]
+    $c bind title <Enter> [itcl::code $this LegendTitleAction enter]
+    $c bind title <Leave> [itcl::code $this LegendTitleAction leave]
     # Reset the item coordinates according the current size of the plot.
     $c itemconfigure title -text $title
@@ -2197,15 +2208,17 @@
 
 # ----------------------------------------------------------------------
-# USAGE: _dropdown post
-# USAGE: _dropdown unpost
-# USAGE: _dropdown select
-#
-# Used internally to handle the dropdown list for this combobox.  The
-# post/unpost options are invoked when the list is posted or unposted
-# to manage the relief of the controlling button.  The select option
-# is invoked whenever there is a selection from the list, to assign
-# the value back to the gauge.
-# ----------------------------------------------------------------------
-itcl::body Rappture::VtkSurfaceViewer::Combo {option} {
+# USAGE: LegendTitleAction post
+# USAGE: LegendTitleAction enter
+# USAGE: LegendTitleAction leave
+# USAGE: LegendTitleAction save
+#
+# Used internally to handle the dropdown list for the fields menu combobox.
+# The post option is invoked when the field title is pressed to launch the
+# dropdown.  The enter option is invoked when the user mouses over the field
+# title. The leave option is invoked when the user moves the mouse away
+# from the field title.  The save option is invoked whenever there is a
+# selection from the list, to alert the visualization server.
+# ----------------------------------------------------------------------
+itcl::body Rappture::VtkSurfaceViewer::LegendTitleAction {option} {
     set c $itk_component(view)
     switch -- $option {
@@ -2219,16 +2232,16 @@
             tk_popup $itk_component(fieldmenu) $x $y
         }
-        activate {
+        enter {
             $c itemconfigure title -fill red
         }
-        deactivate {
+        leave {
             $c itemconfigure title -fill $itk_option(-plotforeground)
         }
-        invoke {
+        save {
             $itk_component(field) value $_curFldLabel
             AdjustSetting -field
         }
         default {
-            error "bad option \"$option\": should be post, unpost, select"
+            error "bad option \"$option\": should be post, enter, leave or save"
         }
     }
@@ -2320,5 +2333,5 @@
                 -activeforeground $itk_option(-plotforeground) \
                 -font "Arial 8" \
-                -command [itcl::code $this Combo invoke]
+                -command [itcl::code $this LegendTitleAction save]
             set _fields($fname) [list $label $units $components]
             if { $_curFldName == "" } {
Index: /branches/multichoice/gui/scripts/vtkviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/vtkviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/vtkviewer.tcl	(revision 6371)
@@ -104,5 +104,5 @@
     private method ReceiveDataset { args }
     private method ReceiveImage { args }
-    private method ReceiveLegend { colormap title vmin vmax size }
+    private method ReceiveLegend { colormap title min max size }
     private method RequestLegend {}
     private method Rotate {option x y}
@@ -595,7 +595,4 @@
     }
     array set params $settings
-    set params(-description) ""
-    set params(-param) ""
-    array set params $settings
 
     if {$params(-color) == "auto" || $params(-color) == "autoreset"} {
@@ -634,5 +631,4 @@
         set _dlist [lreplace $_dlist $pos $pos]
         array unset _obj2ovride $dataobj-*
-        array unset _settings $dataobj-*
         set changed 1
     }
@@ -695,5 +691,5 @@
             return $dlist
         }
-        -image {
+        "-image" {
             if {[llength $args] != 2} {
                 error "wrong # args: should be \"get -image view\""
@@ -709,5 +705,5 @@
         }
         default {
-            error "bad option \"$op\": should be -objects or -image"
+            error "bad option \"$op\": should be -objects, -visible or -image"
         }
     }
@@ -2588,5 +2584,5 @@
     radiobutton $inner.vtk_button -text "VTK data file" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Helvetica 9 " \
+        -font "Arial 9" \
         -value vtk
     Rappture::Tooltip::for $inner.vtk_button "Save as VTK data file."
@@ -2866,5 +2862,5 @@
 
 # ----------------------------------------------------------------------
-# USAGE: ReceiveLegend <colormap> <title> <vmin> <vmax> <size>
+# USAGE: ReceiveLegend <colormap> <title> <min> <max> <size>
 #
 # Invoked automatically whenever the "legend" command comes in from
@@ -2872,7 +2868,7 @@
 # specified <size> will follow.
 # ----------------------------------------------------------------------
-itcl::body Rappture::VtkViewer::ReceiveLegend { colormap title vmin vmax size } {
-    set _limits(vmin) $vmin
-    set _limits(vmax) $vmax
+itcl::body Rappture::VtkViewer::ReceiveLegend { colormap title min max size } {
+    set _limits(vmin) $min
+    set _limits(vmax) $max
     set _title $title
     if { [IsConnected] } {
